{{

2014/11/17 na: start of development
Demonstration of New Buttons object on a Quickstart board

First step: test behavior of PCB-resistive buttons on QS-Board

}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  onems = 80_000
  {{ Inkr. geber }}   ' if both pins 0 : no incremental encoder
  PinA = 6
  PinB = 7

  {{ Buttons }}
  MaxButt   =  8    ' Number of buttons to check
  Butt00Pin = 0    ' pin number
  Butt01Pin = 1    ' pin number
  Butt02Pin = 2    ' pin number
  Butt03Pin = 3    ' pin number
  Butt04Pin = 4    ' pin number
  Butt05Pin = 5    ' pin number


  #1, St_Idle, St_UP_, St_Relax, St_Dwn, Trans1U, Trans2U, Trans3U, Trans1D, Trans2D, Trans3D, Trans4
  
OBJ


  Butt          : "QSButtons.spin"
  ToBu          : "ToucButt.spin"

CON 'Commands for Touch Buttons Detector
'  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ToBuVers = -3  ' Process version at return has to be negative as the number of parameters passed at call is positive!
  NmbToBuPar = 03 ' Touch Button Detector process: number of parameters
DAT  PrCBToBu long @ToBuCmd, @ToBuRegi, @DecayTim                                                 

ToBuCmd     long  0 ' to control the Touch Button Detector process
ToBuRegi    long  0 ' This register reflects the pins decayed state, at start: Pins to detect
DecayTim    long  0 ' Time to allow signal decay



CON 'Commands for Button and Encoder input
  #1, Idle, Run   ' Load Parameters, .... to be updated, now just simple
  ButtVers = -4  ' Process version at return has to be negative as the number of parameters passed at call is positive!
  ButtPola = 1    ' 0: low active button, 1: high active button
  ButtMode = 1    ' 0: read pin directly, 1: Read Pins from Register, 2: Matrix?

  NmbButtPar = 07 ' Button process: number of parameters
DAT  PrCBButt long @ButtCmd, @ButtCoun, @ButtPins, @ButtStat, @ButtClck, @ButtDClk, @ToBuRegi                                                      

ButtCmd     long  0 ' to control the Button process
ButtCoun    long  MaxButt ' Counter of the quadrature input, at start: the number of buttons to check
ButtPins    long  Butt00Pin, Butt01Pin, Butt02Pin, Butt03Pin, Butt04Pin, Butt05Pin ', Butt06Pin, Butt07Pin, Butt08Pin, Butt09Pin, Butt10Pin
ButtStat    long  PinA<<5+PinB, ButtPola, ButtMode, 0, 0, 0, 0, 0, 0, 0, 0   ' Status of the button  (Init Incremental encoder pins)
ButtClck    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is clicked
ButtDClk    long  0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0   ' Button is double clicked


TimePres    long 0 ' 1/5 sek fr Dauererkennung
TimeFull    long 0 ' 10 Sekunden fr ganze Fahrt
TimePart    long 0 '  3 Sekunden fr etwas Fahrt
TimeRela    long 0 '  3 Sekunden fr etwas Fahrt

Timer       long 0 ' Timer Value




PUB Main   | VersCOG, Stat, PressFlg, oldState, AnyClick, Warner, i

  Warner := ClkFreq/3

  ' Start the touch button detector first
  DecayTim := CLKFREQ / 100
  ToBuRegi := $FF                           ' Have pin 0 to 7 as input
  ToBuCmd  := NmbToBuPar                    ' Number of parameters passed to the process
  VersCOG  := ToBu.start(@PrCBToBu, @@0) -1 ' start Touch button detector
  if VersCOG~>4 <> ToBuVers      ' check for correct version
    Warner := ClkFreq/20

  ' Start the button process
  ButtCmd  := NmbButtPar     ' Number of parameters passed to the process
  VersCOG  := Butt.start(@PrCBButt, @@0) -1 ' start Button & quadrature input; i: 16*Version + ID-Cog

  if VersCOG~>4 <> ButtVers      ' check for correct version
    Warner := ClkFreq/20

  dira [23..16] ~~

  repeat
    !outa[23]
    outa[0+16] := ButtClck[0]
    outa[1+16] := ButtDClk[1]
    if ButtStat[3] > 0
      outa[3+16]~~
    else  
      outa[3+16]~
    if  ButtDClk[2]
      ButtDClk[2] := 0
      !outa[2+16]
    if  ButtDClk[5]
      ButtDClk[5] := 0
      repeat i from 0 to MaxButt-1
        ButtClck[i] := 0
        ButtDClk[i] := 0



  
  TimePres    := 450         ' 1 ms sek fr Dauererkennung
  TimeFull    := ClkFreq* 3'10  ' 10 Sekunden fr ganze Fahrt
  TimePart    := ClkFreq* 1'3  '  3 Sekunden fr etwas Fahrt
  TimeRela    := ClkFreq/3  ' 1/10 sek Entspannung


  


PRI CmdInvok (CmdPtr, Cmd, Stat) ' Wait until process idle, output cmd, wait for acknowledge, return "Stat" for documentation/debuging purposes
    repeat while long[CmdPtr]
    long[CmdPtr] := Cmd  
    repeat while long[CmdPtr]
    Result := Stat

DAT
